package com.maroontress.sanctuary;

import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.List;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
   Ʊ롼פ˽°륳ѥɡʹ¤ΡΡ󷿡ˤǤ
*/
public class Compounds {

    /** 롼 */
    private Group group;

    /** ¤ */
    private LinkedList<Compound> structs;

    /**  */
    private LinkedList<Compound> unions;

    /**  */
    private LinkedList<Compound> enums;

    /** ȥåץ٥륳ѥ */
    private LinkedList<ToplevelCompound> toplevelCompounds;

    /**
       ѥɤΥåȤޤ

       @param g 롼
    */
    public Compounds(final Group g) {
	group = g;
	structs = new LinkedList<Compound>();
	unions = new LinkedList<Compound>();
	enums = new LinkedList<Compound>();
	toplevelCompounds = new LinkedList<ToplevelCompound>();
    }

    /**
       ݡȤΥΡɥꥹȤɲäޤ

       @param nodes export
    */
    public void addExports(final NodeList nodes) {
	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    Export m = new Export(group, elem);
	    try {
		addCompound(m, m.getType());
	    } catch (Exception e) {
		throw new NodeException(elem, "unknown type");
	    }
	    group.addKeyword(m.getName());
	}
    }

    /**
       ѥɤɲäޤ

       @param compound ѥ
       @param type struct/union/enum
    */
    public void addCompound(final Compound compound, final String type) {
	if (type.equals("struct")) {
	    structs.add(compound);
	} else if (type.equals("union")) {
	    unions.add(compound);
	} else if (type.equals("enum")) {
	    enums.add(compound);
	} else {
	    throw new UnknownCompoundException(type);
	}
    }

    /**
       ȥåץ٥륳ѥɤΥΡɥꥹȤɲäޤ

       @param nodes struct/union/enum
    */
    public void addToplevelCompunds(final NodeList nodes) {
	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    String name = elem.getNodeName();
	    ToplevelCompound m;
	    QualifiedName tag = group.expandImpliedNS(elem, "tag");
	    QualifiedName as = group.expandImpliedNS(elem, "alias");

	    if (tag.getQualified().equals("")
		&& as.getQualified().equals("")) {
		throw new NodeException(elem, "nameless compound.");
	    }
	    if (name.equals("struct")) {
		m = new StructUnion(group, "struct", elem, tag, as);
		structs.add(m);
	    } else if (name.equals("union")) {
		m = new StructUnion(group, "union", elem, tag, as);
		unions.add(m);
	    } else if (name.equals("enum")) {
		m = new Enum(group, elem, tag, as);
		enums.add(m);
	    } else {
		throw new NodeException(elem, "unknown element name");
	    }
	    toplevelCompounds.add(m);
	    group.addKeyword(m.getName());
	    group.addKeyword(as);
	}
    }

    /**
       ȥåץ٥륳ѥɤΥɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	for (ToplevelCompound m : toplevelCompounds) {
	    wr.println("");
	    m.printCode(wr);
	}
    }

    /**
       ѥɤHTMLǽϤޤ

       @param wr 饤
       @param label "Struct" ޤ "Union" ޤ "Enum"
       @param s ѥɤΥꥹ
    */
    private void printHtmlSummary(final PrintWriter wr, final String label,
				  final List<Compound> s) {
	if (s.size() == 0) {
	    return;
	}
	wr.println("    <h2>" + label + " Summary</h2>");
	for (Compound c : s) {
	    c.printCompoundSummary(wr);
	}
    }

    /**
       HTMLɥȤϤޤ

       @param wr 饤
    */
    public void printHtmlSummary(final PrintWriter wr) {
	printHtmlSummary(wr, "Struct", structs);
	printHtmlSummary(wr, "Union", unions);
	printHtmlSummary(wr, "Enum", enums);
    }

    /**
       ѥɤξܺ٤HTMLǽϤޤ

       @param wr 饤
       @param label "Struct" ޤ "Union" ޤ "Enum"
       @param s ѥɤΥꥹ
    */
    private void printHtmlDetail(final PrintWriter wr, final String label,
				 final List<Compound> s) {
	if (s.size() == 0) {
	    return;
	}
	wr.println("    <h2>" + label + " Detail</h2>");
	for (Compound c : s) {
	    c.printCompoundDetail(wr);
	}
    }

    /**
       HTMLξܺ٥ɥȤϤޤ

       @param wr 饤
    */
    public void printHtmlDetail(final PrintWriter wr) {
	printHtmlDetail(wr, "Struct", structs);
	printHtmlDetail(wr, "Union", unions);
	printHtmlDetail(wr, "Enum", enums);
    }

    /**
       ѥɤξܺ٤TeXǽϤޤ

       @param wr 饤
       @param label "Struct" ޤ "Union" ޤ "Enum"
       @param s ѥɤΥꥹ
    */
    private void printTexCompoundDetail(final PrintWriter wr,
					final String label,
					final List<Compound> s) {
	if (s.size() == 0) {
	    return;
	}
	wr.println("\\S" + label.toLowerCase());
	for (Compound c : s) {
	    c.printTexCompoundDetail(wr);
	}
    }

    /**
       TeXξܺ٥ɥȤϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	printTexCompoundDetail(wr, "Struct", structs);
	printTexCompoundDetail(wr, "Union", unions);
	printTexCompoundDetail(wr, "Enum", enums);
    }
};
