package com.maroontress.sanctuary;

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ¤Τޤ϶ΤΥФΥåȤǤ
*/
public class Members implements Components {

    /** ФΥꥹ */
    private LinkedList<Member> v;

    /**
       ѥɥФɲäޤ

       @param g 롼
       @param m ѥɥ
       @param type struct/union/enum
       @param elem structmember/unionmember/enumember
    */
    private void addCompoundMember(final Group g, final CompoundMember m,
				   final String type, final Element elem) {
	try {
	    g.addCompound(m, type);
	} catch (Exception e) {
	    throw new NodeException(elem, "unknown type");
	}
	g.addKeyword(m.getCompoundName());
    }

    /**
       롼פ˽°빽¤Τޤ϶ΤΥФޤ

       @param g 롼
       @param parentName Ф°빽¤Τޤ϶Τ̾
       @param elem memberǡstructmemberǡunionmemberǡ
       enummemberǡޤmethod
       @return ¤Τޤ϶ΤΥ
    */
    private Member createMember(final Group g, final QualifiedName parentName,
				final Element elem) {
	if (elem.getNodeName().equals("structmember")) {
	    QualifiedName tag = g.expandImpliedNS(elem, "tag");
	    StructUnionMember m
		= new StructUnionMember(g, parentName, "struct", tag, elem);
	    addCompoundMember(g, m, "struct", elem);
	    return m;
	} else if (elem.getNodeName().equals("unionmember")) {
	    QualifiedName tag = g.expandImpliedNS(elem, "tag");
	    StructUnionMember m
		= new StructUnionMember(g, parentName, "union", tag, elem);
	    addCompoundMember(g, m, "union", elem);
	    return m;
	} else if (elem.getNodeName().equals("enummember")) {
	    QualifiedName tag = g.expandImpliedNS(elem, "tag");
	    EnumMember m = new EnumMember(g, parentName, tag, elem);
	    addCompoundMember(g, m, "enum", elem);
	    return m;
	} else if (elem.getNodeName().equals("methodmember")) {
	    Member m = new MethodMember(g, parentName, elem);
	    g.addKeyword(QualifiedName.append(parentName, "." + m.getName()));
	    return m;
	} else if (elem.getNodeName().equals("member")) {
	    String type = g.expandAT(elem, "type");
	    g.importTags(type);
	    Member m = new Member(g, parentName, type, elem);
	    g.addKeyword(QualifiedName.append(parentName, "." + m.getName()));
	    return m;
	} else {
	    throw new NodeException(elem, "unknown element name");
	}
    }

    /**
       ФΥåȤޤ

       @param g 롼
       @param type ΥФ°빽¤Τޤ϶Τη
       @param nodes memberǤΥΡɥꥹ
    */
    public Members(final Group g, final QualifiedName type,
		   final NodeList nodes) {
	v = new LinkedList<Member>();

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    v.add(createMember(g, type, elem));
	}
    }

    public void printCode(final PrintWriter wr, final String indent) {
	for (Member m : v) {
	    m.printCode(wr, indent);
	}
    }

    public void printSummary(final PrintWriter wr) {
	for (Member m : v) {
	    m.printSummary(wr);
	}
    }

    public void printDetail(final PrintWriter wr) {
	for (Member m : v) {
	    wr.println("<hr>");
	    m.printDetail(wr);
	}
    }

    public void printTexDetail(final PrintWriter wr) {
	for (Member m : v) {
	    m.printTexDetail(wr);
	}
    }
}
