package com.maroontress.sanctuary.xclass;

import com.maroontress.sanctuary.Location;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;

/**
   ƻҴط֤̾ΰ֤Ǥ
*/
public final class XLocation extends Location {

    /** ʸ֤̾Υϥåޥå */
    private static HashMap<String, XLocation> map;

    static {
        map = new HashMap<String, XLocation>();
    }

    /** ʥ饹̾ */
    private String fqcn;

    /**  */
    private XLocation parent;

    /** ҤΥꥹ */
    private ArrayList<XLocation> children;

    /** ΤΥ󤫤ɤ */
    private boolean isKnown;

    /**
       ƻҴط֤̾ΰ֤ޤ

       @param packageName ѥå̾
       @param name ̾
       @param fqcn ʥ饹̾
    */
    private XLocation(final String packageName, final String name,
		      final String fqcn) {
	super(packageName, name);
	this.fqcn = fqcn;
	parent = null;
	children = new ArrayList<XLocation>();
	isKnown = false;
    }

    /**
       ƻҴط֤̾ΰ֤ޤ

       @param fqcn ̾
       @return ̾
    */
    public static XLocation intern(final String fqcn) {
        XLocation loc = map.get(fqcn);
        if (loc != null) {
            return loc;
        }
        int k = fqcn.lastIndexOf('.');
        String packageName
	    = (k == -1) ? "" : fqcn.substring(0, k).replace('.', '_');
        String className = fqcn.substring(k + 1);
        loc = new XLocation(packageName, className, fqcn);
        map.put(fqcn, loc);
        return loc;
    }

    /**
       Τꤷޤ
    */
    public void setKnown() {
        isKnown = true;
    }

    /**
       ΤΥ饹ɤޤ

       @return Τξtrue
    */
    public boolean isKnown() {
        return isKnown;
    }

    /**
       Ҥɲäޤ

       @param child 
    */
    private void addChild(final XLocation child) {
	children.add(child);
    }

    /**
       Ƥꤷޤ

       @param parent 
    */
    public void setParent(final XLocation parent) {
        this.parent = parent;
	parent.addChild(this);
    }

    /**
       Ƥޤ

       @return 
    */
    public XLocation getParent() {
        return parent;
    }

    /**
       Ҥޤ

       @return Ҥ
    */
    public XLocation[] getChildren() {
	XLocation[] array = children.toArray(new XLocation[0]);
	Arrays.sort(array, new Comparator<XLocation>() {
            public int compare(final XLocation loc1, final XLocation loc2) {
                return loc1.getPrefix().compareTo(loc2.getPrefix());
            }
	});
	return array;
    }

    /**
       ץեåޤ

       @return ץեå
    */
    public String getImplPrefix() {
        return getPackageName() + "_impl_" + getClassName();
    }

    /**
       Υѥޤ

       @return Υѥ
    */
    public String getImplPath() {
        return getImplPrefix().replace('_', File.separatorChar);
    }

    /**
       ʸǻϤޤ륯饹̾ޤ

       1ʸʸϾʸѴޤǤʤСǽʸ
       ʸ2ʸܤʸξϡǽʸʸˤޤ
       ƬϢ³2ʸʾ夬ʸξϡϢ³ʸκǸ
       ʸʳʸˤޤ:

       A: a
       Abcde: abcde
       AbCde: abCde
       ABcde: aBcde
       ABCde: abCde

       @param s 饹̾
       @return ʸǻϤޤ륯饹̾
    */
    private String getAscendName(final String s) {
        if (s.length() < 2) {
            return s.toLowerCase();
        }
        if (Character.isLowerCase(s.charAt(0))) {
            return s;
        }
        if (Character.isUpperCase(s.charAt(0))
            && Character.isLowerCase(s.charAt(1))) {
            return s.substring(0, 1).toLowerCase() + s.substring(1);
        }
        int k;
        for (k = 1; Character.isUpperCase(s.charAt(k)); ++k) {
            continue;
        }
        --k;
        return s.substring(0, k).toLowerCase() + s.substring(k);
    }

    /**
       ֤̾Υ饹̾ѾطˤƥˡʷǼޤ

       ά̾ʸǻϤޤ̾Ѵ֤ޤĤ˴ά̾Ʊ
       ̾Υ饹¸ߤϡ˥ѥå̾ + "_" ֤
       

       @return 饹Υ̾
    */
    public String getClassMember() {
        String name = getAscendName(getClassName());
	XLocation loc;
        for (loc = getParent();
	     loc != null && !getAscendName(loc.getClassName()).equals(name);
	     loc = loc.getParent()) {
	    continue;
        }
        if (loc == null) {
            return name;
        }
        return getPackageName() + "_" + name;
    }

    /**
       ʥ饹̾ޤ

       @return ʥ饹̾
    */
    public String getFQCN() {
	return fqcn;
    }
}
