package com.maroontress.sanctuary.xclass;

import com.maroontress.sanctuary.Group;
import com.maroontress.sanctuary.Parameter;
import com.maroontress.sanctuary.Tex;
import java.io.PrintWriter;

/**
   󥹥󥹥᥽åɤthisǤ
*/
public class XThisParameter extends Parameter {

    /** type° */
    private String type;

    /**
       󥹥󥹥᥽åɤthisޤ

       @param g 롼
    */
    public XThisParameter(final Group g) {
        type = "union " + g.getPackageName() + "_" + g.getName();
    }

    /**
       {@inheritDoc}
    */
    @Override public String getCode() {
        return type + " $this";
    }

    /**
       {@inheritDoc}
    */
    @Override public String getName() {
        return "$this";
    }

    /**
       {@inheritDoc}
    */
    @Override public String getHTML(final Group g) {
        return g.getHTML(type) + "&nbsp;" + "<i>this</i>";
    }

    /**
       {@inheritDoc}
    */
    @Override public String getTEX(final Group g) {
        String argName = "\\Sarg{" + Tex.safe("this") + "}";
        return g.getTEX(type) + " " + argName;
    }

    /**
       {@inheritDoc}
    */
    @Override public void printDetail(final PrintWriter wr) {
        wr.println("<i>this</i> - instance.<br>\n");
    }

    /**
       {@inheritDoc}
    */
    @Override public void printTexDetail(final PrintWriter wr) {
        String argName = "\\Sarg{" + Tex.safe("this") + "}";

        wr.println("\\item[" + argName + "] instance.");
    }
}
